{
           ===============================
           www.geocities.com/iniwebsiteku/
           ===============================

     activeWALLPAPER CHANGER ver. 1.0
     ===========================
     
     tujuan  : mengganti tampilan wallpaper pada desktop

     keterangan :
           wallpaper akan diubah setiap interval waktu tertentu < 1menit, 10menit,... >
           wallpaper akan ditampilkan secara :
              Center <ditengah layar monitor>,
              Tile <wallpaper akan ditampilkan seperti ubin>,
              Stretch <wallpaper ditampilkan selalu memenuhi layar monitor>

     history :
           lihat file Wallpaper.dpr


     *********************************************************
     *********************************************************
     ***** oleh : ADI NUGROHO                            *****
     ***** email : adi_nugroho_citra@yahoo.com           *****
     *****                                               *****
     ***** Jurusan Fisika                                *****
     ***** Fakultas Matematika dan Ilmu Pengetahuan Alam *****
     ***** UNIVERSITAS GADJAH MADA                       *****
     ***** 2002                                          *****
     *********************************************************
     *********************************************************

}
unit Unit1_Wallpaper;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, FileCtrl, ExtDlgs,

  jpeg,
  registry,
  ShellApi,

  Unit1_Wallpaper_About, Spin, Menus;

type
  TForm1 = class(TForm)
    ButtonOpen: TButton;
    ButtonApply: TButton;
    ButtonAbout: TButton;
    PanelImage_Outer: TPanel;
    OpenPictureDialog1: TOpenPictureDialog;
    ButtonExit: TButton;
    PanelInformasi: TPanel;
    Label3: TLabel;
    Label5: TLabel;
    ListBox1: TListBox;
    TimerAutoChangeWallpaper: TTimer;
    GroupBox1: TGroupBox;
    ComboBoxDisplayStyle: TComboBox;
    Label1: TLabel;
    SpinEditTimeInterval: TSpinEdit;
    Label2: TLabel;
    Label4: TLabel;
    PanelImage_Inner: TPanel;
    Image1: TImage;
    CheckBoxRandom: TCheckBox;
    LabelSumOfFiles: TLabel;
    PopupMenu1: TPopupMenu;
    RestoreForm1: TMenuItem;
    ChangeWallpaper1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    Exit2: TMenuItem;
    Button1: TButton;
    LabelMemory: TLabel;
    TimerAnimasiJudul: TTimer;
    ButtonAddFile: TButton;
    ButtonDeleteFile: TButton;
    ButtonLoadList: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    ButtonStartStop: TButton;
    PanelWatch: TPanel;
    LabelWatch: TLabel;
    TimerWatch: TTimer;
    LabelMemoryInUse: TLabel;
    ButtonSaveList: TButton;
    Label6: TLabel;
    procedure ButtonOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure ButtonApplyClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ButtonAboutClick(Sender: TObject);
    procedure ComboBoxDisplayStyleChange(Sender: TObject);
    procedure TimerAutoChangeWallpaperTimer(Sender: TObject);
    procedure RestoreForm1Click(Sender: TObject);
    procedure ChangeWallpaper1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TimerAnimasiJudulTimer(Sender: TObject);
    procedure ButtonAddFileClick(Sender: TObject);
    procedure ButtonDeleteFileClick(Sender: TObject);
    procedure ButtonSaveListClick(Sender: TObject);
    procedure ButtonLoadListClick(Sender: TObject);
    procedure ButtonStartStopClick(Sender: TObject);
    procedure TimerWatchTimer(Sender: TObject);
  private
    { Private declarations }
     MyBitmap : TBitmap;
     nid : TNotifyIconData;
     AutoChange : boolean;
     ii : integer;
     
     function GetBitmapDimensionsString(const Bitmap:  TBitmap):  string;
     procedure ConvertJPG2BMP (JPG_file : string; BMP_file : string);
     procedure ChangeWallpaper (Gambar: string; DisplayStyle : string; sTile : string);
     procedure ChooseTimeInterval;
     procedure MinimizeToSystemTray;
     procedure RestoreForm;
     procedure IconMessageHandler(var Msg : TMessage); message WM_USER;
     procedure FillListBoxFor1stTime;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  FormTitle: string; 
implementation

{$R *.DFM}

// make it work 'silently' ... in tray
procedure TForm1.MinimizeToSystemTray;
begin
     nid.cbSize := SizeOf(TNotifyIconData);
     nid.Wnd := Handle;
     nid.uID := 0;
     nid.uFlags := NIF_ICON or NIF_TIP or NIF_MESSAGE;
     nid.uCallbackMessage := WM_USER;
     nid.hIcon := Application.Icon.Handle;
     StrPCopy(nid.szTip,'Wallpaper Changer ver. 1.0   Right Click for menu.');
     Shell_NotifyIcon(NIM_ADD,@nid);
     ShowWindow(Application.handle,SW_HIDE);
     Visible := False;
end;

// restore the form, kembalikan tampilan form program utama
procedure TForm1.RestoreForm;
begin
     nid.uFlags := 0;
     Shell_NotifyIcon(NIM_DELETE,@nid);
     ShowWindow(Application.handle,SW_RESTORE);
     Visible := True;
end;

// ketika di tray, jika user melakukan 'double click' maka kembalikan tampilan form utama
// jika tombol kiri mouse ditekan, maka tampilkan popup menu
procedure TForm1.IconMessageHandler(var Msg : TMessage);
var
   Pt : TPoint;
begin
   if Msg.LParam = WM_LBUTTONDBLCLK then
      RestoreForm
   else
      if Msg.LParam = WM_RBUTTONDOWN then
         begin
            GetCursorPos(Pt);
            PopUpMenu1.Popup(Pt.x,Pt.y);
         end;
end;

// saya ingin tahu dimensi gambar < LEBAR x TINGGI >
function TForm1.GetBitmapDimensionsString(const Bitmap:  TBitmap):  string;
begin
    RESULT := '( ' + IntToStr(Bitmap.Width)  + ' x ' +
              IntToStr(Bitmap.Height) + ' ) pixels';
    if   Bitmap.HandleType = bmDDB then RESULT := RESULT + '(DDB)';
end;

// cara untuk mengubah/mengkonversi format JPG menjadi BMP
procedure TForm1.ConvertJPG2BMP (JPG_file : string; BMP_file : string);
var  MyJPGfile : TJPEGImage;
     MyBMPfile : TBitmap;
begin
     MyJPGfile := TJPEGImage.Create;
     with MyJPGfile do
     begin
           LoadFromFile (JPG_file);

           MyBMPfile := TBitmap.Create;
           with MyBMPfile do
           begin
                 Width := MyJPGfile.Width;
                 Height := MyJPGfile.Height;
                 Canvas.Draw (0,0,MyJPGfile);
                 SaveToFile (BMP_file);
                 Free;
           end;
           Free;
     end;
end;

// inti program ini
// ubah wallpaper
procedure TForm1.ChangeWallpaper ( Gambar: string; DisplayStyle : string;
                                   sTile : string);
var  reg : TRegistry;
     FileFormat : string[4];
     NamaFileBMP : string;
begin
{
     lihat Registry Windows , gunakan regedit !
     akan diperoleh hasil sebagai berikut :
           WallpaperStyle = 0  ---> CENTER
           WallpaperStyle = 2  ---> STRETCH

           TileWallpaper = 0   ---> TILE
           TileWallpaper = 1   ---> tidak TILE
}

//  lakukan pengecekan terhadap jenis file yang ada di ListBox
//  jika file tersebut berformat JPG, maka lakukan konversi menjadi BMP
//  dan disimpan di folder c:\windows\ dengan nama MyWallpaper.bmp
//  variabel Gambar diisi dengan hasil pengkonversian file tersebut

//  jika file tersebut berformat BMP, maka langsung dilakukan proses pengubahan wallpaper

     FileFormat := AnsiUpperCase (ExtractFileExt(Gambar));

     if FileFormat = '.JPG' then
     begin
           SetLength (NamaFileBMP,101);
           GetWindowsDirectory (PChar(NamaFileBMP), 100);
           NamaFileBMP := string (PChar(NamaFileBMP));
           NamaFileBMP := NamaFileBMP + '\MyWallpaper.bmp';
           
           ConvertJPG2BMP (Gambar, NamaFileBMP);

           reg := TRegistry.Create ;
           reg.RootKey := HKEY_CURRENT_USER;
           with reg do
           begin
              try
                 if OpenKey ('\Control Panel\Desktop', false) then
                 begin
                    WriteString ('Wallpaper',NamaFileBMP);
                    WriteString ('WallpaperStyle',DisplayStyle);
                    WriteString ('TileWallpaper', sTile);
                 end;
              finally
                 reg.Free;
              end;
           end;

           SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, pChar(NamaFileBMP),
                          SPIF_UPDATEINIFILE or SPIF_SENDCHANGE);

     end
     else

// jika file-nya berformat BMP, maka ...
     if FileFormat = '.BMP' then
     begin
           reg := TRegistry.Create ;
           reg.RootKey := HKEY_CURRENT_USER;
           with reg do
           begin
              try
                 if OpenKey ('\Control Panel\Desktop', false) then
                 begin
                    WriteString ('Wallpaper',Gambar);
                    WriteString ('WallpaperStyle',DisplayStyle);
                    WriteString ('TileWallpaper', sTile);
                 end;
              finally
                 reg.Free;
              end;
           end;

           SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, pChar(Gambar),
                          SPIF_UPDATEINIFILE or SPIF_SENDCHANGE);
     end;
end;

// cari file-file citra untuk diisikan pada ListBox
// format file yang didukung adalah BMP dan JPG
procedure TForm1.ButtonOpenClick(Sender: TObject);
var  MS: TMemoryStatus;
begin
     // informasi tentang memori sistem komputer yang dipakai
     GlobalMemoryStatus(MS);
     LabelMemory.Caption := 'Free Physical Memory :' + #13#10 +
                            '          ' +
                             FormatFloat('#,###" KB"', MS.dwTotalPhys / 1024);
     LabelMemoryInUse.Caption :=  'Memory in use : ' + #13#10 +
                                  '          ' +
                                  Format ('%d %%', [MS.dwMemoryLoad]);
     // --------
     
     OpenPictureDialog1.Options := [ofHideReadOnly,ofAllowMultiSelect,ofEnableSizing];
     // panggil file-file gambar dan tampilkan di FileListBox
     if OpenPictureDialog1.Execute then
     begin
           ListBox1.Items.Assign (OpenPictureDialog1.Files);
     end;

     LabelSumOfFiles.Caption := 'Total : ' + IntToStr (ListBox1.Items.Count) + ' file(s)';

end;

//   atur penampilan FORM
procedure TForm1.FormCreate(Sender: TObject);
var  MS: TMemoryStatus;
begin
     // informasi tentang memori sistem komputer yang dipakai
     GlobalMemoryStatus(MS);
     LabelMemory.Caption := 'Free Physical Memory :' + #13#10 +
                            '          ' +
                             FormatFloat('#,###" KB"', MS.dwTotalPhys / 1024);
     LabelMemoryInUse.Caption :=  'Memory in use : ' + #13#10 +
                                  '          ' +
                                  Format ('%d %%', [MS.dwMemoryLoad]);
     // ----------

     
     FormTitle := '(^_^)  activeWallpaper Changer ver. 1.0  ...   ';

     Form1.Position := poScreenCenter;
     Form1.BorderStyle := bsSingle;
     Form1.BorderIcons := [];           
     OpenPictureDialog1.Options := [ofHideReadOnly,ofAllowMultiSelect,ofEnableSizing];

     // ListBox diisi dulu dengan file-file BMP yang ada di direktori "C:\Windows\"
     FillListBoxFor1stTime;
     LabelSumOfFiles.Caption := 'Total : ' + IntToStr (ListBox1.Items.Count) + ' file(s)';
     
     ButtonApply.Enabled := true;
     ComboBoxDisplayStyle.ItemIndex :=0;

     TimerAutoChangeWallpaper.Enabled := false;
     ComboBoxDisplayStyle.Enabled := true;
     SpinEditTimeInterval.Enabled := true;
     CheckBoxRandom.Enabled := true;
     Label3.Visible := false;
     Label5.Visible := false;  

     ComboBoxDisplayStyle.ItemIndex := 0;

     ii := 0;
     AutoChange := false;

     // jika kursor mouse berada diatas label jam, maka tunjukkan tanggal hari ini 
     LabelWatch.Hint := 'Today is : ' + FormatDateTime ('dddd, dd mmmm yyyy', Date);  
end;

// do you really want to close this program ?
procedure TForm1.ButtonExitClick(Sender: TObject);
begin
   nid.uFlags := 0;
   // If EXIT is selected form the Context menu of Sys Tray Icon
   // It shutdown the applicaiton.
   // Pressing the X button on Main Window only Minimize the Application to System Tray.
   Shell_NotifyIcon(NIM_DELETE,@nid);
   
   Close;
end;

// i want to change my wallpaper
// ABRAKADABRAaaaaaaaaaa
procedure TForm1.ButtonApplyClick(Sender: TObject);
begin
     Screen.Cursor := crHourGlass;
     try
           // center
           if (ComboBoxDisplayStyle.ItemIndex=0) then
              ChangeWallpaper (ListBox1.Items[ListBox1.itemIndex], '0', '0')
           else

           // tile
           if (ComboBoxDisplayStyle.ItemIndex=1) then
              ChangeWallpaper (ListBox1.Items[ListBox1.itemIndex], '0', '1')
           else

           // stretch
           if (ComboBoxDisplayStyle.ItemIndex=2) then
              ChangeWallpaper (ListBox1.Items[ListBox1.itemIndex], '2', '0');

     finally
        Screen.Cursor := crDefault;
        ButtonApply.Enabled := false;
     end;
end;

// user memilih salah satu file,
// show it in TImage sehingga user dapat melihat file gambar yang dipilih
procedure TForm1.ListBox1Click(Sender: TObject);
var  MyPicture : TPicture;
     aHeight, aWidth : integer;
     Ratio : double;
begin
     Screen.Cursor := crHourGlass;
     try
        if assigned (MyBitmap) then MyBitmap.Free;

        MyBitmap := TBitmap.Create;
        MyPicture := TPicture.Create;
        try
              MyPicture.LoadFromFile (ListBox1.Items[ListBox1.itemindex]);
              try
                 MyBitmap.Assign (MyPicture.Graphic);
              except
                    MyBitmap.Width := MyPicture.Graphic.Width;
                    MyBitmap.Height := MyPicture.Graphic.Height;
                    MyBitmap.PixelFormat := pf24bit;
                    MyBitmap.Canvas.Draw (0,0,MyPicture.Graphic);
              end;
        finally
           MyPicture.Free;
        end;

        MyBitmap.PixelFormat := pf24bit;
//      langsung ditampilkan
//        Image1.Picture.Graphic := MyBitmap;

// ............................................................................
//      tampilkan gambar yang dipilih, dengan memperhatikan faktor aspect ratio
//      atau perbandingan antara panjang dan lebar,
//      sehingga gambar dapat ditampilkan pada Image secara wajar dan tidak aneh
        with Image1 do
        begin
              Picture.Graphic := MyBitmap;

              aWidth := Picture.Width;
              aHeight := Picture.Height;
              Ratio := aWidth / aHeight;

              if Ratio < 1.0 then
              begin
                    if Picture.Height > PanelImage_Outer.ClientHeight then
                       aHeight := PanelImage_Outer.ClientHeight;
                    aWidth := trunc (Ratio * aHeight);
              end
              else
              begin
                    if Picture.Width > PanelImage_Outer.ClientWidth then
                       aWidth := PanelImage_Outer.ClientWidth;
                    aHeight := trunc ( aWidth / Ratio);
              end;

              Height := aHeight;
              Width  := aWidth;

              Left := (PanelImage_Outer.ClientWidth div 2) - (aWidth div 2);
              Top  := (PanelImage_Outer.ClientHeight div 2) - (aHeight div 2);
        end;
// ............................................................................
     finally
        Screen.Cursor := crDefault;
     end;

     Label3.Visible := true;
     Label5.Visible := true;
     Label5.Caption := ExtractFileName (ListBox1.Items[ListBox1.itemindex]);
     Label3.Caption := GetBitmapDimensionsString(MyBitmap);

     ButtonApply.Enabled := true;
end;

// want to know WHO is creating this software ..?
procedure TForm1.ButtonAboutClick(Sender: TObject);
begin
     Wallpaper_About.ShowModal;
end;

// pilih cara gambar ditampilkan sebagai wallpaper pada desktop
// ............CENTER
// ............TILE
// ............STRETCH
procedure TForm1.ComboBoxDisplayStyleChange(Sender: TObject);
begin
     ButtonApply.Enabled := true;
end;

// UBAH WALLPAPER !!!
// KHUSUS ditampilkan secara CENTER dan TIDAK diSTRETCH
procedure TForm1.TimerAutoChangeWallpaperTimer(Sender: TObject);
var  i : integer;
begin
     if AutoChange then
     begin
           IF (CheckBoxRandom.Checked=true) then
           begin
           // daftar gambar diacak
                Randomize;
                i := Random (ListBox1.Items.COunt);
                ChangeWallpaper (ListBox1.Items[i], '0', '0');
           end
           ELSE

           begin
           // daftar gambar diurutkan dari urutan pertama sampai terakhir
           // jika sudah sampai pada urutan terakhir, maka diulang lagi dari pertama
                ii := ii + 1;
                if (ii >= ListBox1.Items.Count) then ii := 0;
                ChangeWallpaper (ListBox1.Items[ii], '0', '0');
           end;
     end;
end;

// interval waktu perubahan tampilan wallpaper
procedure TForm1.ChooseTimeInterval;
var  n : integer;
begin
     // misal jika n = 5 --> perubahan setiap 5 menit
     n := SpinEditTimeInterval.Value;

     if n=0 then TimerAutoChangeWallpaper.Enabled := false
     else
          TimerAutoChangeWallpaper.Interval := 1000 * 60 * n;
                                            // 1000 * 60  = 60 detik = 1 menit
end;


// show form as usual
procedure TForm1.RestoreForm1Click(Sender: TObject);
begin
     RestoreForm;
end;

// the popup menu to change wallpaper
procedure TForm1.ChangeWallpaper1Click(Sender: TObject);
begin
     ChangeWallpaper (ListBox1.Items[ListBox1.itemIndex], '0', '0')
end;

// fill listbox with the images in Windows directory (biasanya sih bertipe BMP)
procedure TForm1.FillListBoxFor1stTime;
var  x : integer;
     DirInfo : TSearchRec;
     NamaFolderWindows : string;
     Buffer : array [0..255] of char;
begin
     GetWindowsDirectory (buffer, sizeof(buffer)-1);
     NamaFolderWindows := StrPas(Buffer);             //'c:\windows\';

// cari file-file BMP
     x := FindFirst (NamaFolderWindows + '\*.bmp', FaAnyFile, DirInfo);
     while x=0 do
     begin
           if ((DirInfo.Attr and FaDirectory <> FaDirectory) and
              (DirInfo.Attr and FaVolumeId <> FaVolumeID)) then

           ListBox1.Items.Add (NamaFolderWindows + '\'+ DirInfo.Name);
           Application.ProcessMessages;

           x := FindNext(DirInfo);
     end;
     SysUtils.FindClose (DirInfo);
//   ..............................

// cari file-file JPG
     x := FindFirst (NamaFolderWindows + '\*.jpg', FaAnyFile, DirInfo);
     while x=0 do
     begin
           if ((DirInfo.Attr and FaDirectory <> FaDirectory) and
              (DirInfo.Attr and FaVolumeId <> FaVolumeID)) then

           ListBox1.Items.Add (NamaFolderWindows + '\'+ DirInfo.Name);
           Application.ProcessMessages;

           x := FindNext(DirInfo);
     end;
     SysUtils.FindClose (DirInfo);
//   ..............................
end;

// minimize form to the system tray, so it can work 'silently'
procedure TForm1.Button1Click(Sender: TObject);
begin
     MinimizeToSystemTray;
end;

// animate the caption of form <title bar caption>
procedure TForm1.TimerAnimasiJudulTimer(Sender: TObject);
var i:integer;
begin 
  Application.Title := FormTitle; 
  Form1.Caption := FormTitle;

  for i:=1 to (Length(FormTitle)-1) do 
    FormTitle[i] := Application.Title[i+1];
    
  FormTitle[Length(FormTitle)] := Application.Title[1]; 
end;

// tambahkan file gambar yang diinginkan
procedure TForm1.ButtonAddFileClick(Sender: TObject);
var  i: integer;
begin
     OpenPictureDialog1.Title := 'Add image file ...';

     if OpenPictureDialog1.Execute then
        for i:=0 to OpenPictureDialog1.Files.Count-1 do
           ListBox1.Items.Add (  OpenPictureDialog1.Files.Strings[i]   );

     LabelSumOfFiles.Caption := 'Total : ' + IntToStr (ListBox1.Items.Count) + ' file(s)';
end;

// hapus file yang tidak diinginkan dari listbox
procedure TForm1.ButtonDeleteFileClick(Sender: TObject);
begin
     ListBox1.Items.Delete (ListBox1.ItemIndex);
     Image1.Picture.Graphic := nil;

     LabelSumOfFiles.Caption := 'Total : ' + IntToStr (ListBox1.Items.Count) + ' file(s)';
     Label5.Visible := false;
     Label3.Visible := false;     
end;

// membuat (dan menyimpan) daftar file gambar yang tercantum di ListBox
procedure TForm1.ButtonSaveListClick(Sender: TObject);
var  ListFile : TextFile;
     ImageFileName : string;
     i : integer;
begin
     SaveDialog1.Title := 'Saving list of image files for wallpaper ...';

     if SaveDialog1.Execute then
     begin
           ImageFileName := SaveDialog1.FileName;
           AssignFile (ListFile, ImageFileName);
           Rewrite (ListFile);
           // catat jumlah file yang ada di listbox
           Writeln (ListFile, ListBox1.Items.Count);
           
           for i:=0 to ListBox1.Items.Count-1 do
           begin
                Writeln (ListFile, ListBox1.Items[i]);
           end;
           CloseFile (ListFile);
     end;
end;

// load the image list (*.lst)
procedure TForm1.ButtonLoadListClick(Sender: TObject);
var  ListFile : TextFile;
     ImageFileName : string;
     i,j : integer;
begin
     OpenDialog1.Title := 'Loading file for wallpaper ...';
     
     if OpenDialog1.Execute then
     begin
           ImageFileName := OpenDialog1.FileName;
           AssignFile (ListFile, OpenDialog1.FileName);
           Reset (ListFile);
           Readln (ListFile, i);
           ListBox1.Clear;

           for j:=0 to (i-1) do
           begin
                 Readln (ListFile, ImageFileName);
                 ListBox1.Items.Add (ImageFileName);
           end;

           CloseFile (ListFile);
     end;

     LabelSumOfFiles.Caption := 'Total : ' + IntToStr (ListBox1.Items.Count) + ' file(s)';
end;


// i want to change my wallpaper 'automaticaly' dan dengan
// interval waktu yang saya tentukan sendiri
procedure TForm1.ButtonStartStopClick(Sender: TObject);
begin
     // aktifkan timer
     TimerAutoChangeWallpaper.Enabled := true;
     Form1.ChooseTimeInterval;

     if AutoChange then
     begin
           ButtonStartStop.Caption := 'Start';
           CheckBoxRandom.Enabled := true;

           // options di'enabled'
           ComboBoxDisplayStyle.Enabled := true;
           SpinEditTimeInterval.Enabled := true;
     end
     else
     begin
           ButtonStartStop.Caption := 'Stop';
           CheckBoxRandom.Enabled := false;

           // options di'disabled'
           ComboBoxDisplayStyle.Enabled := false;
           SpinEditTimeInterval.Enabled := false;

           // ubah dulu wallpaper dengan gambar yang dipilih di list box
           ButtonApply.OnClick (Sender);
     end;

     AutoChange := not AutoChange;
     
end;

// what time is it ...?
// what day is today ?
procedure TForm1.TimerWatchTimer(Sender: TObject);
var  DateTime : TDateTime;
     Waktu : string;
begin
     DateTime := Time;
     Waktu := TimeToStr (DateTime);
     LabelWatch.Caption := FormatDateTime ('hh:mm:ss AM/PM', DateTime);
end;

end.
